program phaml_master
use phaml
use phaml_user_mod
implicit none
type(phaml_solution_type) :: soln
call phaml_create(soln)
power=6
call update_usermod(soln)
call phaml_solve_pde(soln, &
                     print_grid_when=PHASES,print_grid_who=MASTER, &
                     solve_init=.false., &
                     max_refsolveloop=1,reftype=H_UNIFORM,degree=5, &
                     task=REFINE_ONLY)
open(unit=21,file="savestiff.dat")
open(unit=22,file="saverhs.dat")
call phaml_store_matrix(soln,stiffness_unit=21,rhs_unit=22)
close(21)
close(22)
call phaml_destroy(soln,finalize_mpi=.false.)
for_mass_matrix = .true.
call phaml_create(soln,eq_type=EIGENVALUE)
power=6
call update_usermod(soln)
call phaml_solve_pde(soln, &
                     print_grid_when=PHASES,print_grid_who=MASTER, &
                     solve_init=.false., &
                     max_refsolveloop=1,reftype=H_UNIFORM,degree=5, &
                     task=REFINE_ONLY)
open(unit=23,file="savemass.dat")
call phaml_store_matrix(soln,mass_unit=23)
close(23)
call phaml_destroy(soln)

end program phaml_master
